/* エレベーターシミュレーション
/* Oh!X 1990-4/5
// V3.00以降専用
// 一応全機種対応（グラフィックがちょっと違うけど）

dim int data(1000,2)
int dataBase=0
enum 
	EMPTY=-1
endenum
int timer=0,passes=0,longest=0,lastX,lastY
float average=0
/*
dim int floor(7,1)
int locArvl=20
/*
dim int Elevator(1)= { 1, 1}
dim int Pass(1)    = {-1,-1}
dim int Vector(1)  = { 0, 0}
dim int Wait(1)    = { 0, 0}
/*
str FONT="Migu-1M-Regular"
font(FONT,16):// 先にフォントを設定してからwidth()を設定する
width(64):// テキスト文字フォントサイズを算出させる
vpriority(TPAGE,GPAGE0,GPAGE1,GPAGE2,GPAGE3)
vpage(B_TPAGE+B_GPAGE0)
/*
initList()
init()
simulation()
end
/*
/*
func initList()
	int i
	for i=0 to 999
		data(i,1)=i+1
	next
	data(1000,1)=EMPTY
endfunc
/*
func int newData()
	int retData
	retData=dataBase
	dataBase=tail(dataBase)
	data(retData,1)=EMPTY
	return(retData)
endfunc
/*
func int head(lst)
	return(data(lst,0))
endfunc
/*
func int tail(lst)
	return(data(lst,1))
endfunc
/*
func int addData(x,lst)
	int nd
	nd=newData()
	data(nd,0)=x
	data(nd,1)=lst
	return(nd)
endfunc
/*
func int concat(lst1,lst2)
	int lst
	lst=lst1
	while tail(lst)<>EMPTY
		lst=tail(lst)
	endwhile
	data(lst,1)=lst2
	return(lst1)
endfunc
/*
func int delData(x,lst)
 int tmp
 int retData
 int i
	if x=lst then {
		retData=tail(lst)
		gc(lst)
	} else {
		retData=lst
		while tail(lst)<>x
			lst=tail(lst)
		endwhile
		tmp=tail(lst)
		data(lst,1)=tail(tmp)
		gc(tmp)
	}
	return(retData)
endfunc
/* 
func gc(gabbage)
	data(gabbage,1)=dataBase
	dataBase=gabbage
endfunc
/*
func printList(lst)
	print "[";
	if lst<>EMPTY then {
		repeat
			print head(lst);
			lst=tail(lst)
		until lst=EMPTY
	}
	print "]";
endfunc
/*
func init()
	int i
	for i=1 to 7
		floor(i,0)=EMPTY
		floor(i,1)=EMPTY
	next
	/*
	hitKey(NO,"開始","Start")
	lastX=0:lastY=511
	display()
	moveElevator(0)
	moveElevator(1)
endfunc
/*
/* Arrival of Passenger
/*
func arrival()
	int ff /* floorFrom
	int ft /* floorTo
	if rnd()>0.3# then return()
	/*
	ff=int(rnd()*7)+1
	repeat
		ft=int(rnd()*7)+1
	until ff<>ft
	if ff<ft then {
		floor(ff,1)=addData(ft,floor(ff,1))
		setTime(floor(ff,1))
		locate(locArvl,(7-ff)*3)
		print chr$(DISP_CTRL_CLEARLINE);
		printList(floor(ff,1))
	} else {
		floor(ff,0)=addData(ft,floor(ff,0))
		setTime(floor(ff,0))
		locate(locArvl,(7-ff)*3+1)
		print chr$(DISP_CTRL_CLEARLINE);
		printList(floor(ff,0))
	}
endfunc
/*
/* Display Floor
/*
func display()
int i,j
	cls()
	for i=1 to 7
		j=8-i
		print j;
		locate(locArvl,csrlin()):printList(floor(j,1))
		print
		locate(locArvl,csrlin()):printList(floor(j,0))
		print:print
	next
endfunc
/*
/* Passengers get off
/*
func getOff(elvNo)
	int chk,tmp
	int flag=0
	int elevator,vector,pass
	elevator=Elevator(elvNo)
	vector=Vector(elvNo)
	pass=Pass(elvNo)
	if pass=EMPTY then return()
	chk=pass
	while chk<>EMPTY
		if head(chk)<>elevator then {
			chk=tail(chk)
		} else {
			tmp=tail(chk)
			pass=delData(chk,pass)
			chk=tmp
			flag=1
		}
	endwhile
	if pass=EMPTY then {
		if vector=1 then {
			if upper(elevator)=0 then {
				if floor(elevator,1 )=EMPTY then vector=0
			}
		} else {
			if lower(elevator)=0 then {
				if floor(elevator,0 )=EMPTY then vector=0
			}
		}
	}
	Wait(elvNo)=Wait(elvNo)+flag
	Vector(elvNo)=vector
	Pass(elvNo)=pass
endfunc
/*
/* Passengers get on
/*
func getOn(elvNo)
	int flag=0
	int elevator,vector,pass
	elevator=Elevator(elvNo)
	vector=Vector(elvNo)
	pass=Pass(elvNo)
	if Wait(elvNo)=1 then return()
	if vector=1 and floor(elevator,1)<>EMPTY then {
		getAverage(floor(elevator,0))
		pass=concat(floor(elevator,1),pass)
		floor(elevator,1)=EMPTY
		locate(locArvl,(7-elevator)*3)
		flag=1
	}
	if vector=-1 and floor(elevator,0)<>EMPTY then {
		getAverage(floor(elevator,0))
		pass=concat(floor(elevator,0),pass)
		floor(elevator,0)=EMPTY
		locate(locArvl,(7-elevator)*3+1)
		flag=1
	}
	if (flag) then {
		printList(EMPTY)
		print chr$(5);
		Wait(elvNo)=Wait(elvNo)+1
	}
	Pass(elvNo)=pass
endfunc
/*
/* Move Elevator
/*
func moveElevator(elvNo)
	int elevator,vector,waittm
	elevator=Elevator(elvNo)
	vector=Vector(elvNo)
	waittm=Wait(elvNo)
	/*
	locate((elvNo+1)*5,(7-elevator)*3)
	print "    "
	/*
	if waittm=0 then {
		elevator=elevator+vector
	} else {
		waittm=0
	}
	if elevator<1 then {
		elevator=1
		vector=0
	}
	if elevator>7 then {
		elevator=7
		vector=0
	}
	/*
	locate(0,25+elvNo)
	print "Elevator" ;elvNo;":";chr$(5);
	printList(Pass(elvNo))
	locate((elvNo+1)*5,(7-elevator)*3)
	print mid$("DownStopUp  ",4*(vector+1)+1,4)
	Elevator(elvNo)=elevator
	Vector(elvNo)=vector
	Wait(elvNo)=waittm
endfunc
/*
func direction(elvNo)
	int elevator,vector,pass
	elevator=Elevator(elvNo)
	vector=Vector(elvNo)
	pass=Pass(elvNo)
	if vector=0 then {
		if floor(elevator,0)<>EMPTY then {
			vector=-1
		} else if floor(elevator,1)<>EMPTY then {
			vector=1
		} else if lower(elevator) then {
			vector=-1
		} else if upper(elevator) then {
			vector=1
		}
	} else {
		if pass=EMPTY then {
			 if vector=1 then {
				if floor(elevator,0 )<>EMPTY then {
					if floor(elevator,1 )=EMPTY then {
						if upper(elevator) =0then vector=-1
					}
				}
			} else if vector=-1 then {
				if floor(elevator,1)<>EMPTY then {
					if floor(elevator,0)=EMPTY then {
						if lower(elevator)=0 then vector=1
					}
				}
			}
		}
	}
	Vector(elvNo)=vector
endfunc
/*
func int upper(n)
int i
	for i=n+1 to 7
		if floor(i,0)<>EMPTY then return(1)
		if floor(i,1)<>EMPTY then return(1)
	next
	return(0)
endfunc
/*
func int lower(n)
int i
	for i=1 to n-1
		if floor(i,0)<>EMPTY then return(1)
		if floor(i,1)<>EMPTY then return(1)
	next
	return(0)
endfunc
/*
/* シミュレーション
/*
func simulation()
str tm
int i  
while timer<768:/* 画面一杯分描画したら終了
	for i=0 to 1
		arrival()
		direction(i)
		getOff(i)
		getOn(i)
		moveElevator(i)
		locate(0,24)
		tm=time$
	next
	timer=timer+1
	wait(0.05)
/* while tm=time$:endwhile
endwhile
locate(0,28)
endfunc
/*
/*
/*
func setTime(lst)
	data(lst,2)=timer
endfunc
func int getTime(lst)
	return (data(lst,2))
endfunc
/*
func getAverage(lst)
	int waitTime
	while lst<>EMPTY
		waitTime=timer-getTime(lst)
		if waitTime>longest then longest=waitTime
		passes=passes+2
		average=(waitTime-average)/passes+average
		lst=tail(lst)
	endwhile
	locate(0,27)
	print using "longest:###, average:###.###";longest,average
	gColor(&h00ffffff)
	line(lastX,lastY,timer,511-average*50)
	lastX=timer
	lastY=511-average*50
endfunc
